import { SearchBody } from '../types';
import { Sort, FieldSortOptions, SortOrder } from '../types/common';
import { AggregationBuilder } from './aggregationBuilder';
import { QueryBuilder } from './queryBuilder';
export interface ElasticBuilder extends AggregationBuilder<ElasticBuilder>, QueryBuilder<ElasticBuilder> {
    sort(field: string): ElasticBuilder;
    sort(field: string, order: SortOrder): ElasticBuilder;
    sort(field: string, config: FieldSortOptions): ElasticBuilder;
    sort(config: Sort): ElasticBuilder;
    from(quantity: number | undefined): ElasticBuilder;
    size(quantity: number | undefined): ElasticBuilder;
    build(): SearchBody;
}
export declare const elasticBuilder: () => ElasticBuilder;
