import { Query, AllQueries, AllFieldQueryConfigs } from '../types/queries';
export interface QueryBuilder<B> {
    query<K extends keyof AllFieldQueryConfigs>(type: K, field: string, config: AllFieldQueryConfigs[K]): B;
    query<K extends keyof AllQueries>(type: K, config: AllQueries[K]): B;
    query(query: Query): B;
    andQuery<K extends keyof AllFieldQueryConfigs>(type: K, field: string, config: AllFieldQueryConfigs[K]): B;
    andQuery<K extends keyof AllQueries>(type: K, config: AllQueries[K]): B;
    andQuery(query: Query): B;
    orQuery<K extends keyof AllFieldQueryConfigs>(type: K, field: string, config: AllFieldQueryConfigs[K]): B;
    orQuery<K extends keyof AllQueries>(type: K, config: AllQueries[K]): B;
    orQuery(query: Query): B;
    notQuery<K extends keyof AllFieldQueryConfigs>(type: K, field: string, config: AllFieldQueryConfigs[K]): B;
    notQuery<K extends keyof AllQueries>(type: K, config: AllQueries[K]): B;
    notQuery(query: Query): B;
    getQuery(): Query;
    hasQuery(): boolean;
}
export interface QueryBuilderData {
    query: {
        and: Query[];
        or: Query[];
        not: Query[];
    };
    minimum_should_match?: number;
}
export declare function buildQueryBuilder<B>(this: B, initialData?: QueryBuilderData): QueryBuilder<B>;
export declare function queryBuilder<B>(this: B): any;
