import { Query } from './queries';
export declare type Script = string | {
    source: string;
    lang?: string;
    params?: {
        [param: string]: any;
    };
} | {
    id: string;
    params?: {
        [param: string]: any;
    };
};
export declare type PrimitiveValue = null | number | string | boolean;
export declare type PrimitiveValueArray = null[] | number[] | string[] | boolean[];
export declare type Coordinate = string | number | [number, number] | {
    lat: number;
    lon: number;
};
export declare type SortOrder = 'asc' | 'desc';
export interface NestedSort {
    path: string;
    filter: Query;
    nested?: NestedSort;
}
export interface FieldSortOptions {
    order?: SortOrder;
    mode?: 'min' | 'max' | 'sum' | 'avg' | 'median';
    nested?: NestedSort;
    missing?: PrimitiveValue;
    unmapped_type?: string;
}
export declare type SortType = string | {
    _geo_distance: {
        order?: SortOrder;
        distance_type?: 'arc' | 'plane';
        mode: 'min' | 'max' | 'median' | 'avg';
        unit?: string;
        distance: string;
        _name?: string;
        validation_method?: 'strict' | 'ignore_malformed' | 'coerce';
        ignore_unmapped?: boolean;
    } | {
        [field: string]: Coordinate | Coordinate[];
    };
} | {
    _script: {
        type: string;
        script: Script;
        order: SortOrder;
    };
} | {
    [field: string]: SortOrder | FieldSortOptions;
};
export declare type Sort = SortType | SortType[];
